from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Directory, Boolean, Float, Int

Gseapy_Ssgsea_V0_1_0 = CommandToolBuilder(tool="gseapy_ssgsea", base_command=["gseapy", "ssgsea"], inputs=[ToolInput(tag="in_data", input_type=File(optional=True), prefix="--data", doc=InputDocumentation(doc="Input gene expression dataset file in txt format. Same\nwith GSEA.")), ToolInput(tag="in_gmt", input_type=String(optional=True), prefix="--gmt", doc=InputDocumentation(doc="Gene set database in GMT format. Same with GSEA.")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="The GSEApy output directory. Default: the current\nworking directory")), ToolInput(tag="in_format", input_type=Boolean(optional=True), prefix="--format", doc=InputDocumentation(doc="File extensions supported by Matplotlib active\nbackend, choose from {'pdf', 'png', 'jpeg','ps',\n'eps','svg'}. Default: 'pdf'.")), ToolInput(tag="in_fs", input_type=Float(optional=True), prefix="--fs", doc=InputDocumentation(doc="height, --figsize width height\nThe figsize keyword argument need two parameters to\ndefine. Default: (6.5, 6)")), ToolInput(tag="in_graph", input_type=Int(optional=True), prefix="--graph", doc=InputDocumentation(doc="Numbers of top graphs produced. Default: 20")), ToolInput(tag="in_no_plot", input_type=Boolean(optional=True), prefix="--no-plot", doc=InputDocumentation(doc="Speed up computing by suppressing the plot output.This\nis useful only if data are interested. Default: False.")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Increase output verbosity, print out progress of your")), ToolInput(tag="in_sample_norm", input_type=String(optional=True), prefix="--sample-norm", doc=InputDocumentation(doc="Sample normalization method. Choose from {'rank',\n'log', 'log_rank','custom'}. Default: rank")), ToolInput(tag="in_no_scale", input_type=Boolean(optional=True), prefix="--no-scale", doc=InputDocumentation(doc="If the flag was set, don't normalize the enrichment\nscores by number of genes.")), ToolInput(tag="in_per_mu_num", input_type=Int(optional=True), prefix="--permu-num", doc=InputDocumentation(doc="Number of random permutations. For calculating\nesnulls. Default: 0")), ToolInput(tag="in_min_size", input_type=Int(optional=True), prefix="--min-size", doc=InputDocumentation(doc="Min size of input genes presented in Gene Sets.\nDefault: 15")), ToolInput(tag="in_max_size", input_type=Int(optional=True), prefix="--max-size", doc=InputDocumentation(doc="Max size of input genes presented in Gene Sets.\nDefault: 2000")), ToolInput(tag="in_weight", input_type=Float(optional=True), prefix="--weight", doc=InputDocumentation(doc="Weighted_score of rank_metrics. For weighting input\ngenes. Default: 0.25")), ToolInput(tag="in_ascending", input_type=Boolean(optional=True), prefix="--ascending", doc=InputDocumentation(doc="Rank metric sorting order. If the -a flag was chosen,\nthen ascending equals to True. Default: False.")), ToolInput(tag="in_seed", input_type=Boolean(optional=True), prefix="--seed", doc=InputDocumentation(doc="Number of random seed. Default: None")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of Processes you are going to use. Default: 1\n")), ToolInput(tag="in_job", input_type=String(), position=0, doc=InputDocumentation(doc="Single Sample GSEA advanced arguments:"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="The GSEApy output directory. Default: the current\nworking directory"))], container="quay.io/biocontainers/gseapy:0.10.4--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gseapy_Ssgsea_V0_1_0().translate("wdl")

